/* store table of configurations with minimal number of bytes 
 * also on disk (v1.4.1 Jan00), N=40 should now work on 4GB-machines
 */
#include "tbase.h"
#include "error.h"
#include <stdlib.h>
#include <stdio.h>


/* l1: packed list of tbase=base-configs, local node only
 * old: tbase *l1 - until Jan00
 * ToDo: at the moment l1 is mapped on file=tmp/l1_0000.dat node_ofs
 */
unsigned char *l1; /* packed list of tbase=base-configs, local node only */

#ifndef TMPDIR        /* 2018-11 added for more flexibility */
#define TMPDIR "tmp/"  /* alternatives: "./" "../tmp/" "/tmp/" */
#endif

char       FILE_l1[64]= TMPDIR "l1_0000.dat";  /* tmp/l1_%3d$(mpi_i).dat */
const char *FILE_l10  = TMPDIR "l1_0000.dat";  /* summed file */
FILE *fl1=NULL;

/* N=40 hit the 1GB file limit => problems??? ofs=file_ofs */
int save_l1(unsigned char *l1, ULong n1, ULong ofs){
  FILE *f1=NULL; size_t t1;
  if (vvv && ofs==0) printf(" write_%s (Bsize=%d)",FILE_l10,(int)Bsize);
  if (vvv) printf(" +%lu=%lu",(unsigned long)n1,(unsigned long)(ofs+n1));
  if (!n1) return 0;
  f1=fopen(FILE_l10,"r+b"); if (!f1) f1=fopen(FILE_l10,"wb");
  if(!f1) { E1("fopen_%s",FILE_l10); return -1; }	/* error */
  if((double)((long)n1 *Bsize)!=((double)n1 )*Bsize)E0("l1: n1-OVL");
  if((double)((long)ofs*Bsize)!=((double)ofs)*Bsize)E0("l1: ofs-OVL");
// * fseek(long)  32bit or 64bit (v2.32 and less)
// * lseek(off_t) 32bit or 64bit (also 64bit for 32bit + LFS) v2.33
  if (fseek(f1,(long)ofs*Bsize,SEEK_SET)) E0("fseek");
  t1=ftell(f1); if(t1!=ofs*Bsize) E0("ftell!=fseek");
  t1=fwrite(l1,Bsize,n1,f1); 
  if(t1!=n1 && n1>0){ ERR(511); /* OSF1-V5.1-732+advFS failes for 2GB? */
    do {  /* cut the 2GB write into 2*1GB writes, Nov04 */
      printf(" wrote %g",(double)t1);
      l1+=t1*Bsize; n1-=t1;
      t1=fwrite(l1,Bsize,((n1>100000000)?100000000:n1),f1);
    } while (t1!=0 && t1!=n1);
  }
  if(t1!=n1){ ERR(510); l1+=t1*Bsize; n1-=t1; t1=fwrite(l1,Bsize,n1,f1); }
  if(t1!=n1){ ERR(510); }
  fclose(f1);
  return 0;
}

// ToDo2012-05-23: add offset, ToDo: replace by open,lseek,read
// called by thread0 only (or all threads??) (ToDo: set option for error)
//   only by numsymconf() 2012-11
//  ToDo: mpi_i%n==0 only + transfer to minimize read-tasks?
int load_l1(unsigned char *l1, ULong n1, ULong ofs){  // Endianess??
  FILE *f1=NULL; size_t t1;
  if (vvv) printf(" load_l1 %s ofs=%g len=%g unit[B]=%d",
                  FILE_l10,1.*ofs,1.*n1,(int)Bsize);
  if (ofs != (ULong)-1) { /* n2=0 happens on crawling sym space  2012-11 */
    f1=fopen(FILE_l10,"rb");
    if(!f1) { E1("load_l1.fopen_%s",FILE_l10); return -1; } /* error */
    /* 2016-01 quantum:/scratch nfs4
       (rw,relatime,vers=4.0,rsize=1048576,wsize=1048576,hard,proto=tcp,
       port=0,timeo=600,retrans=2,sec=sys,local_lock=none)
     */
    if((double)((long)n1*Bsize)!=((double)n1)*Bsize)E0("long-OVL");
    if (fseek(f1,(long)ofs*Bsize,SEEK_SET)) E0("fseek");
    t1=fread(l1,Bsize,n1,f1);
    if(t1!=n1){ ERR(510); l1+=t1*Bsize; n1-=t1; t1=fread(l1,Bsize,n1,f1); }
    if(t1!=n1){ ERR(510); err_fatal=510; }
    fclose(f1);
  }
  if (vvv) printf(" err=%d\n", (int)err_fatal);
  return 0;
}

// putl1() moved to tbase.h 2016-01-12

